;==================================================

#NoEnv
AutoTrim, Off
SetBatchLines, -1

#SingleInstance force
#KeyHistory 0
#UseHook
#Warn
ListLines, Off
Menu, Tray, Click, 1
Menu, Tray, Tip, % RegExReplace(A_ScriptName, "\.[^.]*$")

;==================================================

;Internet Explorer get element under cursor (show borders, show text) (any zoom percentage) - Page 2 - AutoHotkey Community
;https://autohotkey.com/boards/viewtopic.php?f=6&t=29458&start=20

;try this script on:
;NestedFramesExample 1\Example.htm
;NestedFramesExample 2\Example.htm
;NestedFramesExample 3\Example.htm

;another frames example:
;Variables and Expressions
;https://autohotkey.com/docs/Variables.htm

;==================================================

#IfWinActive ahk_class IEFrame
;NOTE: this script is sometimes showing the incorrect border
q:: ;internet explorer - get element under cursor
;show borders around, and get text from, element under cursor
;regardless of zoom percentage of 'Internet Explorer_Server' control
;it could potentially be incorporated into iWB2 Learner

;WinGet, hWnd, ID, A
hWnd := WinGetID("A")
oWB := WBGet("ahk_id " hWnd)

vLogicalXDPI := oWB.document.parentWindow.screen.logicalXDPI
vDeviceXDPI := oWB.document.parentWindow.screen.deviceXDPI
vZoomRatio := vDeviceXDPI / vLogicalXDPI
vLogicalYDPI := oWB.document.parentWindow.screen.logicalYDPI
vDeviceYDPI := oWB.document.parentWindow.screen.deviceYDPI
vZoomRatio2 := vDeviceYDPI / vLogicalYDPI
if !(vZoomRatio = vZoomRatio2)
	MsgBox, % "zoom mismatch:" vZoomRatio "`r`n" vZoomRatio2

;ControlGet, hCtl, Hwnd,, Internet Explorer_Server1, % "ahk_id " hWnd
;WinGetPos, vCtlX, vCtlY, vCtlW, vCtlH, % "ahk_id " hCtl
hCtl := ControlGetHwnd("Internet Explorer_Server1", "ahk_id " hWnd)
WinGetPos(vCtlX, vCtlY, vCtlW, vCtlH, "ahk_id " hCtl)

vSleep := 500
vColRGB := 0x0000FF

;IID_IWebBrowserApp := "{0002DF05-0000-0000-C000-000000000046}"
;IID_IHTMLWindow2 := "{332C4427-26CB-11D0-B483-00C04FD90119}"

oFrame := oWB, vFrame := 0, oFrame0 := ComObject(9, ComObjQuery(oFrame.document.parentWindow.frames[vFrame], "{332C4427-26CB-11D0-B483-00C04FD90119}", "{332C4427-26CB-11D0-B483-00C04FD90119}"), 1)
oFrame := oWB, vFrame := 1, oFrame1 := ComObject(9, ComObjQuery(oFrame.document.parentWindow.frames[vFrame], "{332C4427-26CB-11D0-B483-00C04FD90119}", "{332C4427-26CB-11D0-B483-00C04FD90119}"), 1)
oFrame := oFrame1, vFrame := 0, oFrame1_0 := ComObject(9, ComObjQuery(oFrame.document.parentWindow.frames[vFrame], "{332C4427-26CB-11D0-B483-00C04FD90119}", "{332C4427-26CB-11D0-B483-00C04FD90119}"), 1)
oFrame := oFrame1, vFrame := 1, oFrame1_1 := ComObject(9, ComObjQuery(oFrame.document.parentWindow.frames[vFrame], "{332C4427-26CB-11D0-B483-00C04FD90119}", "{332C4427-26CB-11D0-B483-00C04FD90119}"), 1)
oFrame := ""
oArray := [oWB, oFrame0, oFrame1, oFrame1_0, oFrame1_1]

vOutput := ""
Loop, % oArray.Length()
{
	oFrame := oArray[A_Index]
	oElt := oFrame.document.documentElement
	oRect := oElt.getBoundingClientRect()

	if JEE_Between(A_Index, 1, 1)
		vPow := 1
	else if JEE_Between(A_Index, 2, 3)
		vPow := 2
	else if JEE_Between(A_Index, 4, 5)
		vPow := 3

	vFrameX := oFrame.document.parentWindow.screenLeft
	vFrameY := oFrame.document.parentWindow.screenTop
	vEltX := vFrameX * vZoomRatio**vPow
	vEltY := vFrameY * vZoomRatio**vPow
	vEltW := (oRect.right - oRect.left) * vZoomRatio
	vEltH := (oRect.bottom - oRect.top) * vZoomRatio
	;vEltW := vEltH := 300

	JEE_Borders(vEltX, vEltY, vEltW, vEltH, vSleep, vColRGB)
}

return
#IfWinActive

;==================================================

;slight modification (by jeeswg) of WBGet by jethrow
WBGet(WinTitle:="ahk_class IEFrame", Svr:=0)
{
	local
	static msg := DllCall("user32\RegisterWindowMessage", "Str","WM_HTML_GETOBJECT", "UInt")
	, IID := "{0002DF05-0000-0000-C000-000000000046}" ;IID_IWebBrowserApp
	;, IID := "{332C4427-26CB-11D0-B483-00C04FD90119}" ;IID_IHTMLWindow2

	hWnd := WinExist(WinTitle)
	if !Svr
	&& !(Svr := ControlGetVisible("Internet Explorer_Server1", "ahk_id " hWnd))
	{
		Loop, 1000
		{
			if ControlGetVisible("Internet Explorer_Server" (A_Index+1), "ahk_id " hWnd)
			{
				Svr := A_Index+1
				break
			}
		}
	}

	lResult := SendMessage(msg, 0, 0, "Internet Explorer_Server" Svr, "ahk_id " hWnd)
	if (lResult != "")
	{
		VarSetCapacity(GUID,16,0)
		if (DllCall("ole32\CLSIDFromString", "WStr","{332C4425-26CB-11D0-B483-00C04FD90119}", "Ptr",&GUID) >= 0)
		{
			pdoc := 0
			DllCall("oleacc\ObjectFromLresult", "Ptr",lResult, "Ptr",&GUID, "UPtr",0, "Ptr*",pdoc)
			obj := ComObject(9,ComObjQuery(pdoc,IID,IID),1)
			ObjRelease(pdoc)
			return obj
		}
	}
}

;==================================================

;if vNum between %vLim1% and %vLim2%
JEE_Between(vNum, vLim1, vLim2, vOpt:="ii")
{
	local
	if (vOpt = "ii") || (vOpt = "")
		return (vLim1 <= vNum && vNum <= vLim2)
	else if (vOpt = "xx")
		return (vLim1 < vNum && vNum < vLim2)
	else if (vOpt = "xi")
		return (vLim1 < vNum && vNum <= vLim2)
	else if (vOpt = "ix")
		return (vLim1 <= vNum && vNum < vLim2)
}

;==================================================

; ;e.g.
; q:: ;draw borders around the active window/control
; hWnd := WinGetID("A")
; vCtlClassNN := JEE_ControlGetFocusClassNN("ahk_id " hWnd)
; hWnd := ControlGetHwnd(vCtlClassNN, "ahk_id " hWnd)
; WinGetPos(vCtlX, vCtlY, vCtlW, vCtlH, "ahk_id " hWnd)
; JEE_Borders(vCtlX, vCtlY, vCtlW, vCtlH)
; return

JEE_Borders(vPosX, vPosY, vPosW:=0, vPosH:=0, vTime:=1000, vColRGB:=0xFFFF00, vBdrW:=5, vBdrH:=5)
{
	local
	;based on example at the very bottom of:
	;WinSet
	;https://autohotkey.com/docs/commands/WinSet.htm
	static vWinClass := "AHKBordersClass"
	;static vFunc := A_ThisFunc "WndProc" ;doesn't work
	;static pWndProc := RegisterCallback(vFunc, "F")
	static pWndProc := 0
	static vPIs64 := (A_PtrSize=8)
	static vSize := vPIs64?80:48

	if !pWndProc
		pWndProc := RegisterCallback(A_ThisFunc "WndProc", "F")
	VarSetCapacity(WNDCLASSEX, vSize, 0)
	NumPut(vSize, &WNDCLASSEX, 0, "UInt") ;cbSize
	NumPut(pWndProc, &WNDCLASSEX, 8, "Ptr") ;lpfnWndProc
	vColBGR := ((0xFF & vColRGB) << 16) + (0xFF00 & vColRGB) + ((0xFF0000 & vColRGB) >> 16)
	hBrush := DllCall("gdi32\CreateSolidBrush", "UInt",vColBGR, "Ptr")
	NumPut(hBrush, &WNDCLASSEX, vPIs64?48:32, "Ptr") ;hbrBackground
	NumPut(&vWinClass, &WNDCLASSEX, vPIs64?64:40, "Ptr") ;lpszClassName
	DllCall("user32\RegisterClassEx", "Ptr",&WNDCLASSEX, "UShort")

	vPosX -= vBdrW, vPosY -= vBdrH
	vPosW += vBdrW*2, vPosH += vBdrH*2

	vDHW := A_DetectHiddenWindows
	DetectHiddenWindows("On")
	;WS_POPUP := 0x80000000
	;WS_EX_TOOLWINDOW := 0x80 ;WS_EX_TOPMOST := 0x8
	vWinText := "", vWinStyle := 0x80000000, vWinExStyle := 0x88
	hWnd := DllCall("user32\CreateWindowEx", "UInt",vWinExStyle, "Str",vWinClass, "Str",vWinText, "UInt",vWinStyle, "Int",vPosX, "Int",vPosY, "Int",vPosW, "Int",vPosH, "Ptr",0, "Ptr",0, "Ptr",0, "Ptr",0, "Ptr")
	vBdrL := vBdrR := vBdrW
	vBdrT := vBdrB := vBdrH
	oArray := [vPosW, vPosH, vBdrL, vPosW-vBdrR, vBdrT, vPosH-vBdrB]
	vRegion := Format("0-0 {1:}-0 {1:}-{2:} 0-{2:} 0-0" " {3:}-{5:} {4:}-{5:} {4:}-{6:} {3:}-{6:} {3:}-{5:}", oArray*)
	WinSetRegion(vRegion, "ahk_id " hWnd)
	WinShow("ahk_id " hWnd)
	DetectHiddenWindows(vDHW)

	Sleep(vTime)
	DllCall("user32\DestroyWindow", "Ptr",hWnd)
}

JEE_BordersWndProc(hWnd, uMsg, wParam, lParam)
{
	local
	return DllCall("user32\DefWindowProc", "Ptr",hWnd, "UInt",uMsg, "UPtr",wParam, "Ptr",lParam, "Ptr")
}

;==================================================

;commands as functions (AHK v2 functions for AHK v1) - AutoHotkey Community
;https://autohotkey.com/boards/viewtopic.php?f=37&t=29689
#Include JEEAhk1FC.ahk

;==================================================
